import java.applet.Applet;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.MediaTracker;
import java.awt.image.BufferedImage;
import java.net.URL;

import javax.imageio.ImageIO;

import next_masao.CharacterObject;
import next_masao.MasaoEventListener;
import next_masao.MasaoGame;

/**
 * 
 */

/**
 * @title ܂RXgNV m 
 *				JavaApplet zupNX
 * @author Fukuda
 */
public class MasaoConstruction extends Applet implements MasaoEventListener {
	private static final long serialVersionUID = 1L;

	public BufferedImage offscreen_img;			//  ItXN[
	public Graphics2D offscreen_g;				//  ItXN[

	public MasaoGame masao = null;				//  ܂RXgNV
	
	
	//  
	public void init() {
	
	
		//  ItXN[쐬
		offscreen_img = new BufferedImage(640,480,BufferedImage.TYPE_INT_ARGB);
		offscreen_g = offscreen_img.createGraphics();
	
		//  ܂RXgNV쐬
		masao = new MasaoGame(offscreen_img,(MasaoEventListener)this,(Applet)this);
	}


	//  ʍXV\bh
	public void paint(Graphics g) {


		//  ItXN[`
		g.drawImage(offscreen_img,0,0,this);
	}


	//  Abvf[h\bh
	public void update(Graphics g) {


		//  ㏑Ȃ
		paint(g);
	}
	

	//  ~
	public void stop() {


		//  ܂Xbh~
		masao.stopThread();
	}


	//  ܂`Cxg
	public void masaoDrawEvent() {

		
		//  ĕ`
		repaint();
	}


	//  JavaScript p\bh


	//  Aloe Anime XML Text Zbg
	public boolean setAnimeXML(String h_st) {
		return(masao.setAnimeXML(h_st));
	}
	

	//  nCXRA擾
	public int getHighscore() {
		int modori = 0;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(0);

		//  nCXRA擾
		modori = masao.mp.highscore;
		if(modori < masao.mp.score) {
			modori = masao.mp.score;
		}

		return(modori);
	}
	
	
	//  XRA擾
	public int getScore() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(0);

		return(masao.mp.score);
	}
	

	//  XRAZ
	public boolean addScore(String st1) {
		int point = 0;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  int փLXg
		try {
			point = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}
		
		//  XRAZ
		masao.mp.addScore(point);

		return(true);
	}

	
	//  [h擾
	public int getMode() {
		int modori = 0,mode = 0;


		//  j쐬ĂȂ
		if(masao == null)return(-1);
		
		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);

		//  [h擾
		mode = masao.mp.ml_mode;

		if(mode >= 50  &&  mode < 60) {
			//  ^Cg
			modori = 1;
		}
		else if(mode >= 70  &&  mode < 80) {
			//  Xe[Wԍ\
			modori = 10;
		}
		else if(mode >= 200  &&  mode < 300) {
			//  GfBO
			modori = 300;
		}
		else if(mode >= 300  &&  mode < 400) {
			//  Q[I[o[
			modori = 200;
		}
		else {
			if(masao.mp.ml_mode == 100  &&  masao.mp.slock_con >= 110) {
				//  {X
				modori = 150;
			}
			else {
				//  Q[
				modori = 100;

				//  Xe[WԍZ
				modori += masao.mp.stage;
			}
		}

		return(modori);
	}
	

	//  L[tO擾p
	public int isPressZKey() {
		if(masao.gk == null) return(0);
		if(masao.gk.z_f == true) return(1);
		return(0);
	}
	public int isPressXKey() {
		if(masao.gk == null) return(0);
		if(masao.gk.x_f == true) return(1);
		return(0);
	}
	public int isPressSpaceKey() {
		if(masao.gk == null) return(0);
		if(masao.gk.space_f == true) return(1);
		return(0);
	}
	public int isPressUpKey() {
		if(masao.gk == null) return(0);
		if(masao.gk.up_f == true) return(1);
		return(0);
	}
	public int isPressDownKey() {
		if(masao.gk == null) return(0);
		if(masao.gk.down_f == true) return(1);
		return(0);
	}
	public int isPressLeftKey() {
		if(masao.gk == null) return(0);
		if(masao.gk.left_f == true) return(1);
		return(0);
	}
	public int isPressRightKey() {
		if(masao.gk == null) return(0);
		if(masao.gk.right_f == true) return(1);
		return(0);
	}


	//  l̂wW擾  }bv`bvWn
	public int getMyX() {
		int n;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(-1);

		n = (int)((masao.mp.co_my.x+15)/32)-1;
		if(n < 0) n = 0;
		if(n > 179) n = 179;
		return(n);
	}

	
	//  l̂wW擾  sNZWn
	public int getMyXReal() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(-1);

		return(masao.mp.co_my.x);
	}


	//  lYW擾  }bv`bvWn
	public int getMyY() {
		int n;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(-1);

		n = (int)((masao.mp.co_my.y+15)/32)-10;
		if(n < 0) n = 0;
		if(n > 29) n = 29;
		return(n);
	}


	//  lYW擾  sNZWn
	public int getMyYReal() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(-1);

		return(masao.mp.co_my.y);
	}


	//  l̍Wݒ  }bv`bvWn
	public boolean setMyPosition(String st1,String st2) {
		int x = 0,y = 0;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(false);

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		if(x < 0  ||  x > 179  ||  y < 0  ||  y > 29) return(false);

		//  l̍WZbg
		masao.mp.co_my.x = (x+1)*32;
		masao.mp.co_my.y = (y+10)*32;

		//  l̑xOɂ
		masao.mp.co_my.vx = 0;
		masao.mp.co_my.vy = 0;
		
		return(true);
	}


	//  l̂wWݒ  sNZWn
	public boolean setMyXReal(String st1) {
		int x = 0;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(false);

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  l̍WZbg
		masao.mp.co_my.x = x;

		return(true);
	}


	//  l̂xWݒ  sNZWn
	public boolean setMyYReal(String st1) {
		int y = 0;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(false);

		//  int փLXg
		try {
			y = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  l̍WZbg
		masao.mp.co_my.y = y;

		return(true);
	}


	//  l̕擾
	public int getMyDirection() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(-1);

		return(masao.mp.co_my.direction);
	}


	//  l̕ݒ
	public boolean setMyDirection(String st1) {
		int d = 0;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(false);

		//  int փLXg
		try {
			d = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  Ȓl
		if(d < 0 || d > 1) return(false);
		
		//  l̍WZbg
		masao.mp.co_my.direction = d;

		return(true);
	}


	//  lX̑x擾
	public int getMyVX() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(-1);

		return(masao.mp.co_my.vx);
	}


	//  lY̑x擾
	public int getMyVY() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(-1);

		return(masao.mp.co_my.vy);
	}


	//  lX̑xݒ
	public boolean setMyVX(String st1) {
		int s = 0;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(false);

		//  int փLXg
		try {
			s = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  l̑xZbg
		masao.mp.co_my.vx = s;

		return(true);
	}


	//  lY̑xݒ
	public boolean setMyVY(String st1) {
		int s = 0;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(false);

		//  int փLXg
		try {
			s = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  l̑xZbg
		masao.mp.co_my.vy = s;

		return(true);
	}


	//  \̈̂wW擾
	public int getViewX() {
		int n;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);

		n = (int)((masao.fmap.view_x)/32)-1;
		if(n < 0) n = 0;
		return(n);
	}
	
	
	//  \̈YW擾
	public int getViewY() {
		int n;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);

		n = (int)((masao.fmap.view_y)/32)-10;
		if(n < 0) n = 0;
		return(n);
	}


	//  \̈̂wW擾  sNZWn
	public int getViewXReal() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);

		return(masao.fmap.view_x);
	}


	//  \̈YW擾  sNZWn
	public int getViewYReal() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);

		return(masao.fmap.view_y);
	}


	//  XN[\Ȕ͈͂ݒ肷  }bv`bvWn
	public boolean setScrollArea(String st1,String st2,String st3,String st4) {
		int x1,y1,x2,y2;

		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  int փLXg
		try {
			x1 = Integer.parseInt(st1);
			y1 = Integer.parseInt(st2);
			x2 = Integer.parseInt(st3);
			y2 = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			return(false);
		}
		
		//  sNZW֕ϊ
		x1 = (x1+1)*32;
		x2 = (x2+1)*32;
		y1 = (y1+10)*32;
		y2 = (y2+10)*32;
		
		return(masao.mp.setScrollArea(x1,y1,x2,y2));
	}


	//  XN[\Ȕ͈͂ݒ肷  sNZWn
	public boolean setScrollAreaReal(String st1,String st2,String st3,String st4) {
		int x1,y1,x2,y2;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  int փLXg
		try {
			x1 = Integer.parseInt(st1);
			y1 = Integer.parseInt(st2);
			x2 = Integer.parseInt(st3);
			y2 = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			return(false);
		}
		
		return(masao.mp.setScrollArea(x1,y1,x2,y2));
	}

	
	//  t@C[{[𑕔
	public boolean equipFire() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  t@C[{[𑕔
		masao.mp.my_fire_f = true;

		return(true);
	}


	//  lnɂ邩ǂׂ
	public int isRideGround() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);

		return(masao.mp.jsaIsRideGround());
	}
	

	//  WC[Ƀ}bv`bvZbg
	public boolean setMapchip(String st1,String st2,String st3) {
		int x,y,code;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			code = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		if(code < 0  ||  code > 249) return(false);
		if(x < 0  ||  x > 179  ||  y < 0  ||  y > 29) return(false);
		x = x+1;
		y = y+10;
		
		//  `bvZbg
		masao.fmap.setChipCode(code, x, y, 0);

		return(true);
	}


	//  wiC[Ƀ}bv`bvZbg
	public boolean setMapchip2(String st1,String st2,String st3) {
		int x,y,code;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			code = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		if(code < 0  ||  code > 255) return(false);
		if(x < 0  ||  x > 179  ||  y < 0  ||  y > 29) return(false);
		x = x+1;
		y = y+10;
		
		//  `bvZbg
		masao.fmap.setChipCode(code, x, y, 1);

		return(true);
	}


	//  WC[̃}bv`bv擾
	public int getMapchip(String st1,String st2) {
		int x,y,code;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
		}
		catch (NumberFormatException e) {
			return(-1);
		}

		if(x < 0  ||  x > 179  ||  y < 0  ||  y > 29) return(-1);
		x = x+1;
		y = y+10;

		//  `bv擾
		code = masao.fmap.getChipCode(x, y, 0);

		return(code);
	}


	//  wiC[̃}bv`bv擾
	public int getMapchip2(String st1,String st2) {
		int x,y,code;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
		}
		catch (NumberFormatException e) {
			return(-1);
		}

		if(x < 0  ||  x > 179  ||  y < 0  ||  y > 29) return(-1);
		x = x+1;
		y = y+10;

		//  `bv擾
		code = masao.fmap.getChipCode(x, y, 1);

		return(code);
	}


	//  Xe[WJn 1 ɐݒ肳
	public int getJSMes() {


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(0);
	
		return(masao.mp.jsa_jsmes);
	}
	
	
	//  JSMes ɐݒ肷
	public boolean setJSMes(String st1) {
		int mes;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);
	
		//  int փLXg
		try {
			mes = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  bZ[WZbg
		masao.mp.jsa_jsmes = mes;

		return(true);
	}
	

	//  L[R[h擾
	public int getKeyCode() {


		//  Q[L[쐬ĂȂ
		if(masao.gk == null) return(0);
	
		return(masao.gk.key_code);
	}
	

	//  L[R[hZbg
	public boolean resetKeyCode() {


		//  Q[L[쐬ĂȂ
		if(masao.gk == null) return(false);
	
		//  L[R[hZbg
		masao.gk.key_code = 0;
		
		return(true);
	}
	
	
	//  ꌾbZ[W\
	public boolean showMessage(String st1,String st2,String st3,String st4,String st5) {
		int time;
	

		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);
		
		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			time = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}
	
		//  ꌾbZ[W\
		masao.mp.showMessage(time*4, st2, st3, st4, st5);
		
		return(true);
	}


	/**
	 * 摜ǂݍ 
	 * @param filename		t@Cl[
	 * @return				摜
	 */ 
	public BufferedImage newImageOnLoad(String filename) {
		BufferedImage n_img = null;


		//  摜ǂݍ
		try {
			n_img = ImageIO.read(new URL(getCodeBase(),filename));
		} 	catch (Exception e) {
			e.printStackTrace();
			return(null);
		}

		//  ǂݍނ܂ő҂
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(n_img,0);
		try {
			mt.waitForID(0);
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		return(n_img);
	}

	
	
	//  VXeŎg摜Zbg
	//	@param st1		ID
	//	@param st2		t@C
	public boolean setSystemImage(String st1,String st2) {
		int id;
		BufferedImage n_img;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  int փLXg
		try {
			id = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  摜ǂݍ
		n_img = newImageOnLoad(st2);
		if(n_img == null) return(false);
		
		if(id == 0) {
			//  ^Cg
			masao.tsb.addListImage(0, n_img);
		}
		else if(id == 1) {
			//  GfBO
			masao.tsb.addListImage(1, n_img);
		}
		else if(id == 2) {
			//  Q[I[o[
			masao.tsb.addListImage(2, n_img);
		}
		else if(id == 4) {
			//  wi摜  Xe[WP
			masao.tsb.addListImage(4, n_img);
		}
		else if(id == 5) {
			//  wi摜  Xe[WQ
			masao.tsb.addListImage(5, n_img);
		}
		else if(id == 6) {
			//  wi摜  Xe[WR
			masao.tsb.addListImage(6, n_img);
		}
		else if(id == 7) {
			//  wi摜  Xe[WS
			masao.tsb.addListImage(7, n_img);
		}

		return(true);
	}
	
	
	/** 摜\
		@param st1		
		@param st2		x
		@param st3		y
		@param st4		t@C
	 */
	public boolean showImage(String st1,String st2,String st3,String st4) {
		int time,x,y;
		BufferedImage n_img;

	
		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			time = Integer.parseInt(st1);
			x = Integer.parseInt(st2);
			y = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  摜ǂݍ
		n_img = newImageOnLoad(st4);
		if(n_img == null) return(false);
		
		//  XgC[W ID9 ֓o^
		masao.tsb.addListImage(9, n_img);

		//  CvO֕\w
		masao.mp.showImage(time*4, x, y);

		return(true);
	}

	
	/** `\
		@param st1		
		@param st2		x
		@param st3		y
		@param st4		width
		@param st5		height
	 */
	public boolean showRect(String st1,String st2,String st3,String st4,String st5) {
		int time,x,y,width,height;

	
		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			time = Integer.parseInt(st1);
			x = Integer.parseInt(st2);
			y = Integer.parseInt(st3);
			width = Integer.parseInt(st4);
			height = Integer.parseInt(st5);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  CvO֕\w
		masao.mp.showRect(time*4, x, y,width,height);

		return(true);
	}

	
	/** ȉ~\
		@param st1		
		@param st2		x
		@param st3		y
		@param st4		width
		@param st5		height
	 */
	public boolean showOval(String st1,String st2,String st3,String st4,String st5) {
		int time,x,y,width,height;

	
		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			time = Integer.parseInt(st1);
			x = Integer.parseInt(st2);
			y = Integer.parseInt(st3);
			width = Integer.parseInt(st4);
			height = Integer.parseInt(st5);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  CvO֕\w
		masao.mp.showOval(time*4, x, y,width,height);

		return(true);
	}

	
	/** y̐Fݒ肷
		@param st1		r
		@param st2		g
		@param st3		b
		@param st4		a
	 */
	public boolean setPenColor(String st1,String st2,String st3,String st4) {
		int r,g,b,a;
		Color color;
	

		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  int փLXg
		try {
			r = Integer.parseInt(st1);
			g = Integer.parseInt(st2);
			b = Integer.parseInt(st3);
			a = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  F쐬
		color = new Color(r,g,b,a);

		//  CvO֕\w
		masao.mp.setPenColor(color);

		return(true);
	}


	/** y̐Fݒ肷
	 @param st1		r
	 @param st2		g
	 @param st3		b
	 */
	public boolean setPenColor(String st1,String st2,String st3) {
		return(setPenColor(st1,st2,st3,"255"));
	}
	
	
	/** Q[W\
		@param st1		l
		@param st2		Q[W̖O
	 */
	public boolean showGauge(String st1,String st2) {
		int value;

	
		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			value = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  CvO֕\w
		masao.mp.showGauge(value, st2);

		return(true);
	}

	
	//  Q[W
	public boolean hideGauge() {

	
		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  Q[W
		masao.mp.hideGauge();

		return(true);
	}


	/* Gzu
	 @param st1		x
	 @param st2		y
	 @param st3		G̃R[h
	 */
	public boolean setEnemy(String st1,String st2,String st3) {
		int x,y,code;
		

		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);
		
		//  int փLXg
		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			code = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			return(false);
		}
	
		//  I[o[t[
		if(x < 0 || x > 179 || y < 0 || y > 29) return(false);
		if(code < 1 || code > 22) return(false);
	
		//  sNZW֕ϊ
		x = (x+1)*32;
		y = (y+10)*32;

		//  Gzu
		switch(code) {
			case 1:		//  T  Eړ^
                masao.mp.setEnemy(1000, x, y);
				break;
			case 2:		//  T  Oi^
				masao.mp.setEnemy(1100, x, y);
				break;
			case 3:		//  T  RC
				masao.mp.setEnemy(1100, x, y);
				masao.mp.setEnemy(1101, x, y);
				masao.mp.setEnemy(1102, x, y);
				break;
			case 4:		//  sJ`[
				masao.mp.setEnemy(1400, x, y);
				break;
			case 5:		//  `R
				masao.mp.setEnemy(1500, x, y);
				break;
			case 6:		//  qmV
				masao.mp.setEnemy(1700, x, y);
				break;
			case 7:		//  |bs[  ㉺ړ^
				masao.mp.setEnemy(1200, x, y);
				break;
			case 8:		//  |bs[  Oi^
				masao.mp.setEnemy(1300, x, y);
				break;
			case 9:		//  |bs[  RH
				masao.mp.setEnemy(1300, x, y);
				masao.mp.setEnemy(1301, x, y);
				masao.mp.setEnemy(1302, x, y);
				break;
			case 10:	//  }
				masao.mp.setEnemy(1600, x, y);
				break;
			case 11:	//  `
				masao.mp.setEnemy(1800, x, y);
				break;
			case 12:	//  ~Y^E
				masao.mp.setEnemy(1900, x, y);
				break;
			case 13:	//  GA[Y
				masao.mp.setEnemy(2000, x, y);
				break;
			case 14:	//  ^CLO
				masao.mp.setEnemy(3000, x, y);
				break;
			case 15:	//  NQb\
				masao.mp.setEnemy(3100, x, y);
				break;
			case 16:	//  d
				masao.mp.setEnemyMissile(1000, x, y);

				masao.gs.play(10);		//  ʉ

				break;
			case 17:	//  ͂σJb^[  
				masao.mp.setEnemyMissile(1110, x, y);

				masao.gs.play(11);		//  ʉ

				break;
			case 18:	//  ͂σJb^[  E
				masao.mp.setEnemyMissile(1160, x, y);

				masao.gs.play(11);		//  ʉ

				break;
			case 19:	//  ΂̕  
				masao.mp.setEnemyMissile(1200, x, y);

				masao.gs.play(14);		//  ʉ

				break;
			case 20:	//  ΂̕  E
				masao.mp.setEnemyMissile(1250, x, y);

				masao.gs.play(14);		//  ʉ

				break;
			case 21:	//  SC  
				masao.mp.setEnemyMissile(1300, x, y);

				masao.gs.play(15);		//  ʉ

				break;
			case 22:	//  SC  E
				masao.mp.setEnemyMissile(1350, x, y);

				masao.gs.play(15);		//  ʉ

				break;
		}
		
		return(true);
	}


	/*
	  XN[bNݒ肷
	 @param st1		x
	 */
	public boolean setScrollLock(String st1) {
		int x;
		

		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);
		

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  XN[bNݒ肷
		masao.mp.setScrollLock(x);

		return(true);
	}


	/*
	  l
	 @param st1		t
	 */
	public boolean setMyMiss(String st1) {
		int t;
		

		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(false);

		//  int փLXg
		try {
			t = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  ͈͊O
		if(t < 1 || t > 4) t = 1;
		
		//  l
		masao.mp.setMyMiss(t);

		//  o
		masao.gs.play(24);
		
		return(true);
	}


	/*
	  lޓ
	 @param st1		t
	 */
	public boolean setMyPress(String st1) {
		int t;
		

		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);
		
		//  vC[ł
		if(masao.mp.co_my.con < 100  ||  masao.mp.co_my.con >= 200) return(false);

		//  int փLXg
		try {
			t = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  ͈͊O
		if(t < 1 || t > 3) t = 1;
		
		//  lޓ
		masao.mp.setMyPress(t);

		//  FX Ƃ̌݊̍WC
		masao.mp.co_my.y -= 10;
		
		//  o
		masao.gs.play(8);
		
		return(true);
	}


	/*
	  l~
	 @param st1		~鎞
	 @param st2		`bvR[h
	 @param st3		
	 */
	public boolean setMyWait(String st1,String st2,String st3) {
		int t,code,d;
		

		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  int փLXg
		try {
			t = Integer.parseInt(st1);
			code = Integer.parseInt(st2);
			d = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  ͈͊O
		if(code < 0  ||  code > 249) return(false);
		if(d < 0  ||  d > 1) d = 0;
		
		//  l~
		masao.mp.setMyWait(t*4, code, d);

		return(true);
	}


	/*
	  l~  Aj
	 @param st1		~鎞
	 @param st2		Aj̖O
	 @param st3		
	 */
	public boolean setMyWaitAnimeName(String st1,String st2,String st3) {
		int t,d;
		

		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  int փLXg
		try {
			t = Integer.parseInt(st1);
			d = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  ͈͊O
		if(d < 0  ||  d > 1) d = 0;
		
		//  l~
		masao.mp.setMyWaitAnimeName(t*4, st2, d);

		return(true);
	}


	/*
	  ʉĐ
	 @param st1		ID
	 */
	public boolean playSound(String st1) {
		int id;
		

		//  CvO쐬ĂȂ
		if(masao.gs == null) return(false);

		//  int փLXg
		try {
			id = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  ͈͊O
		if(id < 1  ||  id > 27) return(false);
		
		//  ʉĐ
		masao.gs.play(id-1);

		return(true);
	}


	/*
	 t@C[{[Ƃ̓蔻s
	 @param st1		x
	 @param st2		y
	 @param st3		width
	 @param st4		height
	 */
	public int attackFire(String st1,String st2,String st3,String st4) {
		int x,y,width,height;
		int i;
		int modori = 0;
		CharacterObject mym;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(0);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(0);

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			width = Integer.parseInt(st3);
			height = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			return(0);
		}

        for (i = 0; i < 9; i++)
        {
            //  t@C[{[̃IuWFNg
            mym = masao.mp.co_mym[i];

            //  Ȃ
            if (mym.con < 1000 || mym.con >= 2000) continue;

            if(mym.x >= x && mym.x < x + width && mym.y >= y && mym.y < y + height) {
            	//  
                if (mym.con == 1500)
                {
                    //  Ol[h

                    //  
                    mym.con = 2000;
                    mym.c4 = 30;

                    //  Z
                    modori += 10;
                }
                else
                {
                    //  t@C[{[

                	//  
                    mym.con = 0;
                    masao.mp.mym_total = 100;

                    //  Z
                    modori++;
                }
            }
        }
		
		return(modori);
	}


	/*
	  ۍUƓ蔻s
	 @param st1		x
	 @param st2		y
	 @param st3		width
	 @param st4		height
	 */
	public int attackTail(String st1,String st2,String st3,String st4) {
		int x,y,width,height;
		int modori;

		//  CvO쐬ĂȂ
		if(masao.mp == null) return(0);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(0);

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			width = Integer.parseInt(st3);
			height = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			return(0);
		}

		//  ۍUƂ̓蔻
		modori = masao.mp.jsaAttackTail(x, y, width, height);
		
		if(modori >= 1) {
			//  

			masao.gs.play(9);		//  ʉ
		
		}

		return(modori);
	}


	/*
	  ͈͓̓G|
	 @param st1		x
	 @param st2		y
	 @param st3		width
	 @param st4		height
	 */
	public int destroyEnemy(String st1,String st2,String st3,String st4) {
		int x,y,width,height;
		int modori = 0;
		CharacterObject oe;
		int i;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(0);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(0);

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			width = Integer.parseInt(st3);
			height = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			return(0);
		}


        for (i = 0; i <= masao.mp.enemy_id_max; i++)
        {
            //  G̃IuWFNg
            oe = masao.mp.co_enemy[i];
        	
        	//  GȂ
            if (oe.con < 1000) continue;

			if(x < oe.x+32  &&  x+width > oe.x  &&  y < oe.y+32  &&  y+height > oe.y) {
                //  

            	//  |
            	modori++;
            	
            	//  Gt@C[{[Ŕ΂
                if (oe.con >= 5000 && oe.con < 7000)
                {
                    //  ǐՋTp
                    oe.c3 = 1;
                }
                else
                {
                    oe.c3 = 0;
                }
                oe.con = 510;
                oe.vy = -120;
                if (masao.mp.co_my.x <= oe.x)
                {
                    oe.vx = 20;
                    oe.chip_code_r = 0;
                }
                else
                {
                    oe.vx = -20;
                    oe.chip_code_r = 1;
                }
            }
        }
		
		//  ʉo
		if(modori > 0) {
            masao.gs.play(9);
		}
			
		return(modori);
	}
	
	
	/*
	  IWiݒu
	 @param st1		x
	 @param st2		y
	 @param st3		width
	 @param st4		height
	 @param st5		
	 */
	public int newYuka(String st1,String st2,String st3,String st4,String st5) {
		int x,y,width,height;
		int modori;
		BufferedImage n_img;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);

		//  int փLXg
		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			width = Integer.parseInt(st3);
			height = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			return(0);
		}

		
		//  쐬
		modori = masao.mp.newYuka(x, y, width, height, st5);

		if(modori < 0) {
			//  쐬łȂ
		}
		else if(st5.equals("rect") == true) {
			//  `̏
		}
		else {
			//  摜̏
			
			//  摜ǂݍ
			n_img = newImageOnLoad(st5);
			if(n_img != null) {
				//  XgC[W ֓o^
				masao.tsb.addListImage(100 + modori, n_img);
			}
		}
		
		return(modori);
	}


	/*
	  IWij
	 @param st1		id
	 */
	public boolean disposeYuka(String st1) {
		int id;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			id = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}
	
	
		return(masao.mp.disposeYuka(id));
	}


	/*
	  IWiɁA摜Zbg
	 @param st1		id
	 @param st2		t@C
	 */
	public boolean setYukaImage(String st1,String st2) {
		int id;
		BufferedImage n_img;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			id = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}
	
		//  I[o[t[
		if(id < 0 || id >= 200) return(false);

		//  `̏łȂ
		if(masao.mp.co_yuka[id].con != 5000) return(false);
		
		//  摜\ɂ
		masao.mp.co_yuka[id].type = 100;
		
		//  摜ǂݍ
		n_img = newImageOnLoad(st2);
		if(n_img != null) {
			//  XgC[W ֓o^
			masao.tsb.addListImage(100 + id, n_img);
		}
		
		return(true);
	}

	
	/*
	  IWiɁAFZbg
	 @param st1		id
	 @param st2		r
	 @param st3		g
	 @param st4		b
	 @param st5		a
	 */
	public boolean setYukaColor(String st1,String st2,String st3,String st4,String st5) {
		int id,r,g,b,a;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			id = Integer.parseInt(st1);
			r = Integer.parseInt(st2);
			g = Integer.parseInt(st3);
			b = Integer.parseInt(st4);
			a = Integer.parseInt(st5);
		}
		catch (NumberFormatException e) {
			return(false);
		}
	
		//  I[o[t[
		if(id < 0 || id >= 200) return(false);

		//  `̏łȂ
		if(masao.mp.co_yuka[id].con != 5000 || masao.mp.co_yuka[id].type != 200) return(false);

		//  FZbg
		masao.mp.co_yuka[id].color =  new Color(r,g,b,a);
		
		return(true);
	}

	
	/*
	  IWiɁAAjZbg
	 @param st1		id
	 @param st2		anime_name
	 @param st3		r
	 */
	public boolean setYukaAnimeName(String st1,String st2,String st3) {
		int id,r;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			id = Integer.parseInt(st1);
			r = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			return(false);
		}
	
		//  I[o[t[
		if(id < 0 || id >= 200) return(false);

		//  `̏łȂ
		if(masao.mp.co_yuka[id].con != 5000) return(false);

		//  Aj̖OZbg
		return(masao.mp.setYukaAnimeName(id,st2,r));
	}

	
	/*
	  IWiɁAWZbg		`
	 @param st1		id
	 @param st2		x
	 @param st3		y
	 */
	public boolean setYukaPosition(String st1,String st2,String st3) {
		int id,x,y;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			id = Integer.parseInt(st1);
			x = Integer.parseInt(st2);
			y = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			return(false);
		}
	
		//  ړ̍WZbg
		return(masao.mp.jsaSetYukaPosition(id, x, y));
	}


	/*
	  IWíA蔻^Cvݒ肷B
	 @param st1		id
	 @param st2		type		1	lƂ̓蔻肠
								2	lƂ̓蔻Ȃ
	 */
	public boolean setYukaType(String st1,String st2) {
		int id,type;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(false);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(false);

		//  int փLXg
		try {
			id = Integer.parseInt(st1);
			type = Integer.parseInt(st2);
		}
		catch (NumberFormatException e) {
			return(false);
		}
	
	
		return(masao.mp.setYukaCrossType(id,type));
	}


	/*
	  IWiɁAlĂ邩ǂ𒲂ׂB
	 @return modori
	 */
	public int isRideYuka(String st1) {
		int modori;


		//  CvO쐬ĂȂ
		if(masao.mp == null) return(-1);

		//  Q[łȂ
		if(masao.mp.ml_mode != 100) return(-1);

		//  int փLXg
		try {
			modori = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(-1);
		}
	
	
		return(masao.mp.isRideYuka(modori));
	}
}
