import java.applet.Applet;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;

import netscape.javascript.JSObject;
import next_masao.MasaoEventListener;
import next_masao.MasaoGame;

/**
 * 
 */

/**
 * @title ܂RXgNV m 
 *				JavaScript Ăяo@\t
 * @author Fukuda
 */
public class MasaoJSS extends MasaoConstruction {
	private static final long serialVersionUID = 1L;

	//  p̃tB[h
	//  public BufferedImage offscreen_img;			//  ItXN[
	//  public Graphics2D offscreen_g;				//  ItXN[
	//  public MasaoGame masao;						//  ܂RXgNV

	//  JavaScript Ăяop
	JSObject jso;								//  JavaScript Ăяop
	Object[] o_jsm = new Object[4];				//  JavaScript \bḧo^p


	//  
	public void init() {
	

		//  JSObject 쐬
		jso = JSObject.getWindow(this);
		
		//  ItXN[쐬
		offscreen_img = new BufferedImage(640,480,BufferedImage.TYPE_INT_ARGB);
		offscreen_g = offscreen_img.createGraphics();
		
		//  ܂RXgNV쐬
		masao = new MasaoGame(offscreen_img,(MasaoEventListener)this,(Applet)this);
		masao.setFPS(2);			//  FPS 20
		masao.fps_lock = true;		//  FPS ύX֎~
	}


	//  ʍXV\bh
	public void paint(Graphics g) {


		//  ItXN[`
		g.drawImage(offscreen_img,0,0,this);
	}

	
	//  ܂`Cxg
	public void masaoDrawEvent() {
		int mode;


		//  JavaScript ̃\bhĂяo
		mode = getMode();
		if(mode < 1) {
			//  łĂȂ
		}
		else if(mode >= 100  &&  mode < 200) {
			//  Q[̏ꍇ

			o_jsm[0] = offscreen_g;
			o_jsm[1] = new Integer(mode);
			o_jsm[2] = new Integer(masao.fmap.view_x);
			o_jsm[3] = new Integer(masao.fmap.view_y);
			jso.call("userJS",o_jsm);
		}
		else {
			//  Q[ȊO

			o_jsm[0] = offscreen_g;
			o_jsm[1] = new Integer(mode);
			o_jsm[2] = new Integer(-9999);
			o_jsm[3] = new Integer(-9999);
			jso.call("userJS",o_jsm);
		}
		
		//  ĕ`
		repaint();
	}


	//  JavaScript p\bh
	
	//  ItXN[̐Fݒ肷
	public boolean setOffscreenColor(String st1,String st2,String st3,String st4) {
		int r = 0,g = 0,b = 0,a = 0;


		try {
			r = Integer.parseInt(st1);
			g = Integer.parseInt(st2);
			b = Integer.parseInt(st3);
			a = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  I[o[t[
		if(r < 0) r = 0;
		if(r > 255) r = 255;
		if(g < 0) g = 0;
		if(g > 255) g = 255;
		if(b < 0) b = 0;
		if(b > 255) b = 255;
		if(a < 0) a = 0;
		if(a > 255) a = 255;

		//  ItXN[̐Fݒ肷
		offscreen_g.setColor(new Color(r,g,b,a));

		return(true);
	}


	//  TCYݒ肷
	public boolean setFontSize(String st1) {
		int size;


		try {
			size = Integer.parseInt(st1);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		if(size <= 0) return(false);

		//  TCYݒ肷
		offscreen_g.setFont(new Font("Dialog",Font.PLAIN,size));

		return(true);
	}


	/** ItXN[ɁA_R̃|S`悷B
	 *  @param  st1		_P̂wW
	 *  @param  st2		_P̂xW
	 *  @param  st3		_Q̂wW
	 *  @param  st4		_Q̂xW
	 *  @param  st5		_R̂wW
	 *  @param  st6		_R̂xW
	 */
	public boolean fillPolygon(String st1,String st2,String st3,String st4,String st5,String st6) {
		int[] px = new int[3];
		int[] py = new int[3];


		try {
			px[0] = Integer.parseInt(st1);
			py[0] = Integer.parseInt(st2);
			px[1] = Integer.parseInt(st3);
			py[1] = Integer.parseInt(st4);
			px[2] = Integer.parseInt(st5);
			py[2] = Integer.parseInt(st6);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  |S`
		offscreen_g.fillPolygon(px,py,3);

		return(true);
	}


	/** ItXN[ɁA_S̃|S`悷B
	 *  @param  st1		_P̂wW
	 *  @param  st2		_P̂xW
	 *  @param  st3		_Q̂wW
	 *  @param  st4		_Q̂xW
	 *  @param  st5		_R̂wW
	 *  @param  st6		_R̂xW
	 *  @param  st7		_ŜwW
	 *  @param  st8		_ŜxW
	 */
	public boolean fillPolygon(String st1,String st2,String st3,String st4,String st5,String st6,String st7,String st8) {
		int[] px = new int[4];
		int[] py = new int[4];


		try {
			px[0] = Integer.parseInt(st1);
			py[0] = Integer.parseInt(st2);
			px[1] = Integer.parseInt(st3);
			py[1] = Integer.parseInt(st4);
			px[2] = Integer.parseInt(st5);
			py[2] = Integer.parseInt(st6);
			px[3] = Integer.parseInt(st7);
			py[3] = Integer.parseInt(st8);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  |S`
		offscreen_g.fillPolygon(px,py,4);

		return(true);
	}


	//  p^[`悷
	public boolean drawPattern(String st1,String st2,String st3,String st4) {
		int x = 0,y = 0,code = 0,r = 0;


		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			code = Integer.parseInt(st3);
			r = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		if(code < 0  ||  code > 249) return(false);
		if(r < 0  ||  r > 3) return(false);

		//  p^[`悷
		offscreen_g.drawImage(masao.ci[0].chip_img[code][r], x, y, this);

		return(true);
	}


	/** ItXN[ɁA摜]ĕ`悷B
	 *  @param	h_img	Image IuWFNg
	 *  @param  st1		wW
	 *  @param  st2		xW
	 *  @param  st3		px (0 - 359)
	 */
	public boolean drawImageRotate(BufferedImage h_img,String st1,String st2,String st3) {
		int x = 0,y = 0,kakudo = 0,nx,ny;
		Graphics2D effect_g;


		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			kakudo = Integer.parseInt(st3);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  Graphics2D ^쐬
		effect_g = offscreen_img.createGraphics();

		//  ]̒SW
		nx = x+(int)(h_img.getWidth(this)/2);
		ny = y+(int)(h_img.getHeight(this)/2);

		//  ]ݒ肷
		effect_g.rotate((float)(kakudo)*3.14f/180f,nx,ny);

		//  `悷
		effect_g.drawImage(h_img,x,y,this);

		//  Graphics2D ^j
		effect_g.dispose();

		return(true);
	}


	/** ItXN[ɁA摜gkĕ`悷B
	 *  @param	h_img	Image IuWFNg
	 *  @param  st1		wW
	 *  @param  st2		xW
	 *  @param  st3		wg嗦
	 *  @param  st4		xg嗦
	 */
	public boolean drawImageScale(Image h_img,String st1,String st2,String st3,String st4) {
		int x = 0,y = 0,scale_x = 100,scale_y = 100;
		Graphics2D effect_g;


		try {
			x = Integer.parseInt(st1);
			y = Integer.parseInt(st2);
			scale_x = Integer.parseInt(st3);
			scale_y = Integer.parseInt(st4);
		}
		catch (NumberFormatException e) {
			return(false);
		}

		//  Graphics2D ^쐬
		effect_g = offscreen_img.createGraphics();

		//  gkݒ肷
		effect_g.translate(x,y);
		effect_g.scale((float)(scale_x)/100f,(float)(scale_y)/100f);

		//  `悷
		effect_g.drawImage(h_img,0,0,this);

		//  Graphics2D ^j
		effect_g.dispose();

		return(true);
	}
}
